#ifndef __gp_inc__
#define __gp_inc__

// #use "gp.lib"

//------------------------------------------------------------------------------
// __try   - appends new exception handler to thread SEH.
//           Use it only with IF until not a part of Aurora.
//           returns always TRUE, but the code inside 'IF' is always executed.
//
// REMEMBER to call __leave or __catch to cleanup!
//------------------------------------------------------------------------------
extern int __try();

//------------------------------------------------------------------------------
// __leave - removes previously installed exception handler. Called from __catch
//           Every __try must be cleaned with __leave or __catch
//------------------------------------------------------------------------------
extern void __leave();

//------------------------------------------------------------------------------
// __catch - if an exception occurs, it returns TRUE, and optionally the
//           exception code, address and printable description (of code)
//------------------------------------------------------------------------------
extern int __catch(
	opt int *ppExceptionCode = NULL,  // pointer to integer
	opt int *ppExceptionAddress = NULL, // pointer to integer
	opt string *ppExceptionDescription = NULL); // pointer to string pointer

//------------------------------------------------------------------------------
// __throw - forces an exception, the function __catch will return TRUE
//           and set exception address to address of the call to __throw,
//           exception code will be set to -2 (custom), the exception
//           description will be set to your custom string passed to __throw
//------------------------------------------------------------------------------
extern void __throw(string *message);


// note for Paul
// __try assumes that the IF code looks like this: (aurora beta 1.3)
// call __try
// test eax,eax         : 2 bytes
// jz near label_if_not : 2 bytes + 4 bytes offset
//                        (offset is used to calculate safe code pointer to continue execution - after if{} )

//------------------------------------------------------------------------------
declare extern GetExceptionCode(),DWORD;
declare extern GetExceptionInformation(),EXCEPTION_POINTERS*;

#endif
