#ifndef __piano_inc__
#define __piano_inc__

struct PIANOKEY
{
	RECT   rc;
	BOOL   fHalftone;
	int    nPressedCount;
	double frequency;
	dstring name[8];
}

class CPiano
{
	declare CPiano();
	declare _CPiano();
	declare Initialize(HWND hwndPiano);
	declare ShowTones(BOOL fShow);
	declare HitTest(int x, int y, PIANOKEY *ppv),BOOL;
	declare HitTestF(double frequency, PIANOKEY *ppv),BOOL;
	declare Play();
	declare GetPressedKeysString(LPSTR *ppv),BOOL;
	declare SetPressedKeysString(LPSTR pszTones);
	declare GetPressedCount(),int;
	declare PressKey(PIANOKEY *pKey, BOOL fPress);
	declare ToggleKey(PIANOKEY *pKey);
	declare Reset();

	declare OnPaint();
	declare OnSize();
	declare InitializeKeys();
	declare OnLButtonDown(int x, int y);
	declare SendNotifyMessage(int code);

	HWND    m_hwnd;
	HDC     m_hdcWindow;
	int     m_screenX;
	SIZE    m_size;
	WNDPROC m_wndproc;
	HDC     m_hdc;
	HBITMAP m_hbm;
	HPEN    m_penWhite;
	HPEN    m_penBlack;
	HPEN    m_penGray;
	HBRUSH  m_hbrWhite;
	HBRUSH  m_hbrBlack;
//	HBRUSH  m_hbrPressed;
	HBRUSH  m_hbrWhitePressed;
	HBRUSH  m_hbrBlackPressed;
	HFONT   m_font;

	PIANOKEY *m_keys;
	int       m_keycount;
	int       m_nPressedCount;
}

// WM_COMMAND notifications
#define PN_CHANGED 0x0001

#endif
