#ifndef __wave_inc__
#define __wave_inc__

#ifndef __spectrum_inc__
#include "spectrum.inc"
#endif

#ifndef __peakmeter_inc__
#include "peakmeter.inc"
#endif

// todo: add streaming
class CWave
{
	declare CWave();
	declare _CWave();
	declare Initialize(HWND hwndWave, CFFT *spectrum, CWavePeak *peakmeter);
	declare SetData(WAVEFORMATEX *format, word *samples, int count, BOOL fOwn, int peak),BOOL;
	declare RedrawSpectrum();
	declare Play(),BOOL;
	declare Stop();
	declare Close();
	declare Normalize();
	declare GetSelection(word *ppSamples, int *ppSamplesCount, int *ppFirst, int *ppLast),BOOL;

	declare GetVolume(),int;
	declare SetVolume(int v);
	declare OnPaint();
	declare OnSize();
	declare CopyWaveBitmap(HDC hdcTo, HDC hdcFrom);
	declare InitializeGrid();
	declare UpdateScrollbar();
	declare HideScrollbar();
	declare Draw(opt int maxSamplesPerPixel=32); // up to 32 samples per pixel
	declare OnMouseWheel(word delta);
	declare OnHScroll(int type);
	declare Scroll(int direction);
	declare OnKeyDown(int vKey);
	declare OnLButtonDown(int x, int y);
	declare OnLButtonUp(int x, int y);
	declare OnMouseMove(int x, int y);
	declare OnTimer(WPARAM wParam);
	declare GetSampleIndexFromPoint(POINT *pt),int;
	declare GetFirstVisibleSample(),int;
	declare GetLastVisibleSample(),int;
	declare GetSamplesInfo(int *ppFirstVisible, int *ppLastVisible, int *ppVisibleCount);
	declare OnPlayDone();
	declare GetDuration(int nSamplesCount),DWORD; // in miliseconds
	declare GetNumberOfSamples(DWORD duration),int; // in miliseconds
	declare ShowInSpectrum(int position, opt int nSamplesCount=-1);
	declare GetSampleCoordinate(int nSampleIndex),int;
	// player
	declare DrawPlayerPositionMarker(int position);
	declare ErasePlayerPositionMarker();
	//
	declare SaveToFile(HANDLE hFile, int SampleStart, int SampleCount);

	HWND    m_hwnd;
	SIZE    m_size;
	WNDPROC m_wndproc;
	HDC     m_hdcWindow;
	HDC     m_hdcGrid;
	HBITMAP m_hbmGrid;
	HDC     m_hdcWave;
	HBITMAP m_hbmWave;
	int     m_screenX;
	int     m_nGridSize;
	
	word   *m_samples;
	int     m_peak;
	int     m_samplesCount;
	float   m_yscale;
	WAVEFORMATEX m_format;
	
	CFFT      *m_spectrum;
	CWavePeak *m_peakmeter;

	int     m_xzoom;
	SCROLLINFO m_scrollinfo;
	// selection
	int     m_FirstSelectedSample;
	int     m_LastSelectedSample;
//	float   m_fSelectionTime;
	// player
	HWAVEOUT m_hWaveOut;
	WAVEHDR  m_waveHdr;
	int      m_PlayerReadPosition; // a copy of m_FirstSelectedSample for Play()
	int      m_PlayerMarkerPosition;
}


// WM_COMMAND notifications
#define PN_STOPPED 0x0001

#endif
